Bug 167974 - Review Request: hugs98 - Haskell Interpreter
Review Request: hugs98 - Haskell Interpreter
Status: CLOSED NEXTRELEASE
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Jens Petersen
Fedora Package Reviews List
http://math.ifi.unizh.ch/fedora/4/i38...
:
Depends On:
Blocks: FE-ACCEPT
  Show dependency treegraph
 
Reported: 2005-09-09 17:28 EDT by Gérard Milmeister
Modified: 2007-11-30 17:11 EST (History)
0 users

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2006-04-23 23:13:45 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:


Attachments (Terms of Use)
hugs98.spec-200503-4.patch (1.55 KB, patch)
2006-04-18 05:45 EDT, Jens Petersen
no flags Details | Diff
hugs98.spec-2005.03-1.fc5.patch (1.68 KB, patch)
2006-04-20 00:21 EDT, Jens Petersen
no flags Details | Diff

  None (edit)
Description Gérard Milmeister 2005-09-09 17:28:20 EDT
Spec: http://math.ifi.unizh.ch/fedora/spec/hugs98.spec
SRPM: http://math.ifi.unizh.ch/fedora/4/i386/SRPMS.gemi/hugs98-200503-2.src.rpm
Description:
Hugs 98 is a functional programming system based on Haskell 98, the de
facto standard for non-strict functional programming languages. Hugs
98 provides an almost complete implementation of Haskell 98,
including:
Comment 1 Jens Petersen 2006-04-18 05:25:12 EDT
Apologies for "sitting" on this for too long.

0) <http://cvs.haskell.org/Hugs/downloads/2005-03/>
Upstream are now using YYYY-MM to label download dirs at least,
so I wonder if it is better to use 2005.03 say for the version.
(eg Gentoo is using 2005.3)

1) rpmlint complains:

W: hugs98 invalid-license BSDish, see License file, GPL, LGPL

I think just calling it BSD would be sufficient.

2) There seems to a small build problem on fc5:
:
Compiling FFI stubs
../../../src/ffihugs -98 -P../../../hugsdir/packages/OpenAL: -i"HsOpenAL.h"
../../../hugsdir/packages/OpenAL/Sound/OpenAL/AL/Buffer.hs -Iinclude
-DCALLCONV=ccall -lopenal
runhugs: Error occurred
ERROR "../../../hugsdir/packages/OpenAL/Sound/OpenAL/AL/BasicTypes.hs":70 -
Undefined type constructor "HTYPE_ALCLAMPD"

Skipping OpenAL package
:

but probably openal support is not that important and
could be skipped for now on fc5.

3) Probably the description should be made more concise.

4) md5sum is good

5) buildrequires need to be updated for modular X: I attach a diff below.

6) builds fine with mock on fc4 and fc5 x86_64

7) Perhaps it is a good idea to configure --with-pthreads?

8) if demos/ (2.3MB) is to be included, it must be subpackaged into
a separate subpackage (say hugs98-demos).

Otherwise looks good to me.  I think if at least 0, 1, 5, and 8 are addressed
this package can be accepted.
Comment 2 Jens Petersen 2006-04-18 05:45:43 EDT
Created attachment 127907 [details]
hugs98.spec-200503-4.patch

some spec fixes for fc5
Comment 3 Gérard Milmeister 2006-04-18 15:18:00 EDT
(In reply to comment #1)
> Apologies for "sitting" on this for too long.
Better late than never :-)

> 0) <http://cvs.haskell.org/Hugs/downloads/2005-03/>
> Upstream are now using YYYY-MM to label download dirs at least,
> so I wonder if it is better to use 2005.03 say for the version.
> (eg Gentoo is using 2005.3)
Ok

> 1) rpmlint complains:
> W: hugs98 invalid-license BSDish, see License file, GPL, LGPL
> I think just calling it BSD would be sufficient.
Ok

> 2) There seems to a small build problem on fc5:
> Skipping OpenAL package
There are quite some incompatibilities between openal 0.0.9
and previous versions.

> 3) Probably the description should be made more concise.
Is the first paragraph enough?

> 5) buildrequires need to be updated for modular X: I attach a diff below.
Ok
> 8) if demos/ (2.3MB) is to be included, it must be subpackaged into
> a separate subpackage (say hugs98-demos).
Ok, but I still install them into /usr/lib/hugs.
One could also subpackage the packages like opengl etc... I prefer
not to, but if you think it is better...
Comment 4 Jens Petersen 2006-04-19 03:36:54 EDT
(In reply to comment #3)

> > 2) There seems to a small build problem on fc5:
> > Skipping OpenAL package
> There are quite some incompatibilities between openal 0.0.9
> and previous versions.

Ok, that's what I suspected.

> > 3) Probably the description should be made more concise.
> Is the first paragraph enough?

Yeah, that should be fine, or it could be a little more verbose if you prefer.

> > 8) if demos/ (2.3MB) is to be included, it must be subpackaged into
> > a separate subpackage (say hugs98-demos).
> Ok, but I still install them into /usr/lib/hugs.

Ok, but a better place would probably be to move them to under /usr/share/doc/.

BTW the two largest subdirs are:

732k	HaXml
1156k	GLUT  (RedBook/Data/leeds.bin 708k)

> One could also subpackage the packages like opengl etc... I prefer
> not to, but if you think it is better...

In the longer term I think it is something we should consider (also for ghc).
For example:

596	X11
616	GLUT  (requires OpenGL)
1908	OpenGL

probably aren't used by that many hugs users, so it might make sense to separate
them out.
Comment 5 Gérard Milmeister 2006-04-19 12:11:31 EDT
Here is the new srpm:
http://math.ifi.unizh.ch/fedora/5/i386/SRPMS.gemi/hugs98-2005.03-1.fc5.src.rpm

* I moved the demos into /usr/share/doc. I also remove the
  Makefile which doesn't make sense in this context.
* I split off the packages x11, opengl, glut and hgl. I hope
  I got the dependencies right. I used lowercase names, because
  I find it aesthetically more pleasing :-) I can change that
  if necessary.
* I make the demos package depend on hugs98-glut and hugs98-hgl,
  since there are demos that use them. I wouldn't want to
  further split the demos package.
Comment 6 Jens Petersen 2006-04-20 00:18:51 EDT
(In reply to comment #5)
> Here is the new srpm:
> http://math.ifi.unizh.ch/fedora/5/i386/SRPMS.gemi/hugs98-2005.03-1.fc5.src.rpm

Thanks.

I think buildrequires libXt-devel covers libICE-devel and libSM-devel,
and also freeglut-devel pulls in mesa-libGL-devel and mesa-libGLU-devel,
and libX11-devel requires xorg-x11-proto-devel anyway.  libX11-devel seems
sufficient for HsXlib and AFAICT libXt is only checked for in configure
but not actually included by any of the library sources.

Also better to keep openal-devel around for when HOpenal gets updated
(ghc-6.4.2 includes a newer version apparently).  And it builds on fc4
anyway.

> * I moved the demos into /usr/share/doc. I also remove the
>   Makefile which doesn't make sense in this context.

Good.

> * I split off the packages x11, opengl, glut and hgl. I hope
>   I got the dependencies right. I used lowercase names, because
>   I find it aesthetically more pleasing :-)

Great. :)

> * I make the demos package depend on hugs98-glut and hugs98-hgl,
>   since there are demos that use them. I wouldn't want to
>   further split the demos package.

Ok.

Btw what is "touch src/stamp-h.in" needed for?  Also seems to me
"make install" is good enough, do the docs really need to be installed
separately?

Otherwise it looks very good to me, thanks.
Comment 7 Jens Petersen 2006-04-20 00:21:56 EDT
Created attachment 128022 [details]
hugs98.spec-2005.03-1.fc5.patch

some more recommended changes
Comment 8 Gérard Milmeister 2006-04-20 11:39:17 EDT
(In reply to comment #6)
> I think buildrequires libXt-devel covers libICE-devel and libSM-devel,
> and also freeglut-devel pulls in mesa-libGL-devel and mesa-libGLU-devel,
> and libX11-devel requires xorg-x11-proto-devel anyway.  libX11-devel seems
> sufficient for HsXlib and AFAICT libXt is only checked for in configure
> but not actually included by any of the library sources.
I would like to leave it as it is. Better too many requirements than
not enough. Maybe there is a bug somewhere but building in mock
without requiring xorg-x11-proto-devel did not succeed.
Also, the build may seem to succeed, and the packages installed, but
the binary modules may not be there! I had quite a fun time to
figure out the requirements.

> Also better to keep openal-devel around for when HOpenal gets updated
> (ghc-6.4.2 includes a newer version apparently).  And it builds on fc4
> anyway.
The problem is, as it seems, that the openal package is then included
but the binary module is not. I will include a commented out
buildreq.
Comment 9 Gérard Milmeister 2006-04-20 13:37:59 EDT
(In reply to comment #6)
> Btw what is "touch src/stamp-h.in" needed for?
It appears that this is necessary so that configure creates
all the necessary files. Without it, the prefix is set to
"/usr/local" for example.

> Also seems to me
> "make install" is good enough, do the docs really need to be installed
> separately?
This installs the documentation into /usr/lib/hugs. Of course
one could let it do this and delete afterwards.

I have made some little changes, same file, same place.
Comment 10 Jens Petersen 2006-04-20 23:06:05 EDT
Ok, dns for your webserver seems to be down at the moment,
but please go ahead and import to cvs.
Comment 11 Gérard Milmeister 2006-04-21 14:24:44 EDT
Thanks,
Builds fine on the buildsystem. Shall I close?
Comment 12 Jens Petersen 2006-04-21 21:38:53 EDT
(In reply to comment #8)
> I would like to leave it as it is. Better too many requirements than
> not enough. Maybe there is a bug somewhere but building in mock
> without requiring xorg-x11-proto-devel did not succeed.
> Also, the build may seem to succeed, and the packages installed, but
> the binary modules may not be there! I had quite a fun time to
> figure out the requirements.

Hmm ok, it seemed to build fine for me in mock without them,
though I didn't do an careful rpmdiff comparison...  I guess some
the early modular X packages had some missing -devel deps,
but I think that is all sorted out now.  Otherwise please report
the problem in bugzilla.

> > Also better to keep openal-devel around for when HOpenal gets updated
> > (ghc-6.4.2 includes a newer version apparently).  And it builds on fc4
> > anyway.
> The problem is, as it seems, that the openal package is then included
> but the binary module is not. I will include a commented out
> buildreq.

Ah, good point.  I suppose one could patch to the latest version released with
ghc-6.4.2.  Anyway it may be an idea to subpackage openal too for FC4 say:
so perhaps a %_with_openal switch would be useful.

(In reply to comment #9)
> > Btw what is "touch src/stamp-h.in" needed for?
> It appears that this is necessary so that configure creates
> all the necessary files. Without it, the prefix is set to
> "/usr/local" for example.

Oh, sounds like a bug then.  In my Fedora Haskell package
I didn't do that, but hadn't noticed any problems, I wasn't
using %configure - dunno if that is related.

> I have made some little changes, same file, same place.

Thanks for your submission and all your work on this.
The package is ACCEPTED.

Please build it for FE4 too. :-)
Comment 13 Gérard Milmeister 2006-04-22 05:54:36 EDT
(In reply to comment #12)
> 
> Ah, good point.  I suppose one could patch to the latest version released with
> ghc-6.4.2.
If you could make a patch, I will make a subpackage for openal.
 
> Please build it for FE4 too. :-)
I suppose this will need xorg-x11-devel instead of the modular deps...
Comment 14 Jens Petersen 2006-04-23 23:13:45 EDT
> If you could make a patch, I will make a subpackage for openal.

Ok, I'll open another bug for that.

> > Please build it for FE4 too. :-)
> I suppose this will need xorg-x11-devel instead of the modular deps...

Thanks for the FE4 build.

Comment 15 Jens Petersen 2006-04-24 00:43:08 EDT
I opened bug 189735 for OpenAL.

Note You need to log in before you can comment on or make changes to this bug.